from odoo import models
from odoo.tools.translate import _lt

from odoo.http import request


class Website(models.Model):
    _inherit = 'website'

    ICON_PATH = "//download.odoocdn.com/icons/%s/static/description/%s"

    BRAND_DATA = {
        'account': dict(title=_lt("Invoicing")),
        'account_accountant': dict(title=_lt("Accounting")),
        'account_asset': dict(title=_lt("Assets Management")),
        'account_auto_transfer': dict(title=_lt("Account Automatic Transfers")),
        'account_bank_statement_import_ofx': dict(title=_lt("Import OFX Bank Statement")),
        'account_bank_statement_import_qif': dict(title=_lt("Import QIF Bank Statement")),
        'account_batch_payment': dict(title=_lt("Batch Payment")),
        'account_check_printing': dict(title=_lt("Check Printing Base")),
        'account_consolidation': dict(title=_lt("Consolidation")),
        'account_sepa': dict(title=_lt("SEPA Credit Transfer")),
        'appointment': dict(title=_lt("Appointments")),
        'approvals': dict(title=_lt("Approvals")),
        'apps': dict(title=_lt("Apps")),
        'base_icon': dict(title=_lt("Module Icon")),
        'board': dict(title=_lt("Dashboards")),
        'calendar': dict(title=_lt("Calendar")),
        'contacts': dict(title=_lt("Contacts")),
        'crm': dict(title=_lt("CRM")),
        'data_cleaning': dict(title=_lt("Data Cleaning")),
        'data_recycle': dict(title=_lt("Data Recycle")),
        'delivery_bpost': dict(title=_lt("bpost Shipping")),
        'delivery_dhl': dict(title=_lt("DHL Shipping")),
        'delivery_easypost': dict(title=_lt("Easypost Shipping")),
        'delivery_fedex': dict(title=_lt("Fedex Shipping")),
        'delivery_sendcloud': dict(title=_lt("Sendcloud Shipping")),
        'delivery_ups': dict(title=_lt("UPS Shipping")),
        'delivery_usps': dict(title=_lt("United States Postal Service (USPS) Shipping")),
        'documents': dict(title=_lt("Documents")),
        'event': dict(title=_lt("Events Organization")),
        'fleet': dict(title=_lt("Fleet")),
        'gamification': dict(title=_lt("Gamification")),
        'google_calendar': dict(title=_lt("Google Calendar")),
        'google_gmail': dict(title=_lt("Google Gmail")),
        'helpdesk': dict(title=_lt("Helpdesk")),
        'helpdesk_account': dict(title=_lt("Helpdesk Account")),
        'helpdesk_fsm': dict(title=_lt("Helpdesk FSM")),
        'helpdesk_repair': dict(title=_lt("Helpdesk Repair")),
        'helpdesk_sale_loyalty': dict(title=_lt("Helpdesk Sale Loyalty")),
        'helpdesk_stock': dict(title=_lt("Helpdesk Stock")),
        'helpdesk_timesheet': dict(title=_lt("Helpdesk Timesheet")),
        'hr': dict(title=_lt("Employees")),
        'hr_appraisal': dict(title=_lt("Appraisals")),
        'hr_attendance': dict(title=_lt("Attendances")),
        'hr_contract': dict(title=_lt("Employee Contracts")),
        'hr_expense': dict(title=_lt("Expenses")),
        'hr_expense_extract': dict(title=_lt("Expense Extract")),
        'hr_holidays': dict(title=_lt("Time Off")),
        'hr_payroll': dict(title=_lt("Payroll")),
        'hr_recruitment': dict(title=_lt("Recruitment")),
        'hr_referral': dict(title=_lt("Employee Referral")),
        'hr_skills': dict(title=_lt("Skills Management")),
        'hr_timesheet': dict(title=_lt("Timesheet")),
        'hr_work_entry_contract': dict(title=_lt("Work Entries - Contracts")),
        'iap': dict(title=_lt("In-App Purchase")),
        'im_livechat': dict(title=_lt("Live Chat")),
        'industry_fsm': dict(title=_lt("Field Service")),
        'industry_fsm_sale': dict(title=_lt("Field Service - Sale")),
        'industry_fsm_stock': dict(title=_lt("Field Service Stock")),
        'iot': dict(title=_lt("Internet of Things")),
        'knowledge': dict(title=_lt("Knowledge")),
        'l10n': dict(title=_lt("Fiscal Localization")),
        'lunch': dict(title=_lt("Lunch")),
        'mail': dict(title=_lt("Discuss")),
        'mail_bot': dict(title=_lt("OdooBot")),
        'maintenance': dict(title=_lt("Maintenance")),
        'marketing_automation': dict(title=_lt("Marketing Automation")),
        'mass_mailing': dict(title=_lt("Email Marketing")),
        'mass_mailing_sms': dict(title=_lt("SMS Marketing")),
        'membership': dict(title=_lt("Members")),
        'microsoft_calendar': dict(title=_lt("Outlook Calendar")),
        'microsoft_outlook': dict(title=_lt("Microsoft Outlook")),
        'mrp': dict(title=_lt("Manufacturing")),
        'mrp_maintenance': dict(title=_lt("Maintenance MRP")),
        'mrp_plm': dict(title=_lt("PLM")),
        'mrp_workorder': dict(title=_lt("MRP II")),
        'partner_autocomplete': dict(title=_lt("Partner Autocomplete")),
        'payment': dict(title=_lt("Payment Engine")),
        'payment_adyen': dict(title=_lt("Adyen Payment Provider")),
        'payment_alipay': dict(title=_lt("Alipay Payment Provider")),
        'payment_aps': dict(title=_lt("Amazon Payment Services Payment Provider")),
        'payment_asiapay': dict(title=_lt("AsiaPay Payment Provider")),
        'payment_authorize': dict(title=_lt("Authorize.Net Payment Provider")),
        'payment_buckaroo': dict(title=_lt("Buckaroo Payment Provider")),
        'payment_custom': dict(title=_lt("Custom Payment Acquirer")),
        'payment_demo': dict(title=_lt("Demo Payment Provider")),
        'payment_flutterwave': dict(title=_lt("Flutterwave Payment Provider")),
        'payment_mercado_pago': dict(title=_lt("Mercado Pago Payment Provider")),
        'payment_mollie': dict(title=_lt("Mollie Payment Provider")),
        'payment_ogone': dict(title=_lt("Ogone Payment Provider")),
        'payment_paypal': dict(title=_lt("Paypal Payment Provider")),
        'payment_payulatam': dict(title=_lt("PayuLatam Payment Provider")),
        'payment_payumoney': dict(title=_lt("PayuMoney Payment Provider")),
        'payment_razorpay': dict(title=_lt("Razorpay Payment Provider")),
        'payment_sepa_direct_debit': dict(title=_lt("Sepa Direct Debit Payment Provider")),
        'payment_sips': dict(title=_lt("Worldline SIPS")),
        'payment_stripe': dict(title=_lt("Stripe Payment Acquirer")),
        'planning': dict(title=_lt("Planning")),
        'point_of_sale': dict(title=_lt("Point of Sale")),
        'pos_preparation_display': dict(title=_lt("PoS Preparation Display")),
        'pos_restaurant': dict(title=_lt("Restaurant")),
        'product': dict(title=_lt("Products & Pricelists")),
        'project': dict(title=_lt("Project")),
        'project_forecast': dict(title=_lt("Project Planning")),
        'project_todo': dict(title=_lt("To-Do")),
        'purchase': dict(title=_lt("Purchase")),
        'quality_control': dict(title=_lt("Quality")),
        'repair': dict(title=_lt("Repair")),
        'sale': dict(title=_lt("Sales")),
        'sale_amazon': dict(title=_lt("Amazon")),
        'sale_ebay': dict(title=_lt("eBay Connector")),
        'sale_management': dict(title=_lt("Sales")),
        'sale_renting': dict(title=_lt("Rental")),
        'sale_subscription': dict(title=_lt("Subscriptions")),
        'sale_timesheet': dict(title=_lt("Sales Timesheet")),
        'settings': dict(title=_lt("Settings")),
        'sign': dict(title=_lt("Sign")),
        'sms': dict(title=_lt("SMS Gateway")),
        'snailmail': dict(title=_lt("Snail Mail")),
        'social': dict(title=_lt("Social Marketing")),
        'social_facebook': dict(title=_lt("Social Facebook")),
        'social_instagram': dict(title=_lt("Social Instagram")),
        'social_linkedin': dict(title=_lt("Social Linkedin")),
        'social_twitter': dict(title=_lt("Social Twitter")),
        'social_youtube': dict(title=_lt("Social Youtube")),
        'spreadsheet_dashboard': dict(title=_lt("Spreadsheet dashboard")),
        'stock': dict(title=_lt("Inventory")),
        'stock_barcode': dict(title=_lt("Warehouse Management Barcode Scanning")),
        'survey': dict(title=_lt("Survey")),
        'test_exceptions': dict(title=_lt("Test Exceptions")),
        'timer': dict(title=_lt("Timer")),
        'timesheet_grid': dict(title=_lt("Timesheets")),
        'transifex': dict(title=_lt("Transifex Integration")),
        'unknown': dict(title=_lt("Unknown"), png="icon.png", svg="icon.svg"),
        'utm': dict(title=_lt("UTM Trackers")),
        'voip': dict(title=_lt("VOIP")),
        'voip_onsip': dict(title=_lt("VOIP OnSIP")),
        'web_mobile': dict(title=_lt("Android & iPhone")),
        'web_studio': dict(title=_lt("Studio")),
        'web_unsplash': dict(title=_lt("Unsplash Image Library")),
        'website': dict(title=_lt("Website")),
        'website_blog': dict(title=_lt("Blog")),
        'website_crm': dict(title=_lt("Contact Form")),
        'website_crm_partner_assign': dict(title=_lt("Resellers")),
        'website_customer': dict(title=_lt("Customer References")),
        'website_enterprise': dict(title=_lt("Website Enterprise")),
        'website_event': dict(title=_lt("Events")),
        'website_event_questions': dict(title=_lt("Questions on Events")),
        'website_event_sale': dict(title=_lt("Online Event Ticketing")),
        'website_event_track': dict(title=_lt("Advanced Events")),
        'website_form_project': dict(title=_lt("Online Task Submission")),
        'website_forum': dict(title=_lt("Forum")),
        'website_google_map': dict(title=_lt("Google Maps")),
        'website_helpdesk_forum': dict(title=_lt("Helpdesk: Help Center")),
        'website_helpdesk_livechat': dict(title=_lt("Website IM Livechat Helpdesk")),
        'website_helpdesk_slides': dict(title=_lt("Website Slides Helpdesk")),
        'website_hr_recruitment': dict(title=_lt("Online Jobs")),
        'website_links': dict(title=_lt("Link Tracker")),
        'website_livechat': dict(title=_lt("Live Chat")),
        'website_mass_mailing': dict(title=_lt("Newsletter Subscribe Button")),
        'website_membership': dict(title=_lt("Online Members Directory")),
        'website_partner': dict(title=_lt("Website Partner")),
        'website_payment': dict(title=_lt("Website Payment")),
        'website_sale': dict(title=_lt("eCommerce")),
        'website_sale_comparison': dict(title=_lt("Product Comparison")),
        'website_sale_delivery': dict(title=_lt("eCommerce Delivery")),
        'website_sale_digital': dict(title=_lt("Digital Products")),
        'website_sale_loyalty': dict(title=_lt("Coupons & Promotions")),
        'website_sale_stock': dict(title=_lt("Product Availability")),
        'website_sale_wishlist': dict(title=_lt("Shopper's Wishlist")),
        'website_slides': dict(title=_lt("eLearning")),
        'website_twitter': dict(title=_lt("Twitter Snippet")),
        'website_twitter_wall': dict(title=_lt("Twitter Wall")),
        'whatsapp': dict(title=_lt("WhatsApp")),
    }

    def brand_assets(self, module, key=False, icon_class='', card_class=''):
        data = self.BRAND_DATA.get(module, self.BRAND_DATA['unknown']).copy()
        data['title'] = str(data['title'])  # force getting translation with current lang
        data['src_png'] = self.ICON_PATH % (module, data.get('png', 'icon.png'))
        data['src_png_hi'] = self.ICON_PATH % (module, data.get('png', 'icon-hi.png'))
        data['src_pdf'] = self.ICON_PATH % (module, data.get('pdf', 'icon.pdf'))
        data['src_svg'] = self.ICON_PATH % (module, data.get('svg', 'icon.svg'))
        data['icon'] = """<img src='%s' title='Icon %s' class="%s" />""" % (data['src_png'], data['title'], icon_class)
        data['card'] = """<div class="%s">%s %s </div>""" % (card_class, data['icon'], data['title'])
        if key and key in data:
            return data[key]
        return data

    def get_phones(self, country_code=False):
        if request and not country_code:
            country_code = request.geoip.country_code

        action = self.env.ref('openerp_website.ir_act_server_get_phone_numbers').sudo()
        return action.with_context(country_code=country_code).run()

    def _get_livechat_channel_info(self):
        """
            This override allows to force channel in some condition.
            E.g. if HR is connected in a channel X and that we are on page '/jobs.*'
                 we use the RH channel X.
            It only works to start the conversation, once the user started a thread, he
            will keep this channel as 'preferred' while it doesn't close his conversation.
        """
        self.ensure_one()
        website = self
        if self.env.context.get('force_channel'):
            channel = self.channel_id.browse(int(self.env.context['force_channel']))
            if channel.sudo().user_ids:
                website = self.new({'channel_id': channel.id})
        return super(Website, website)._get_livechat_channel_info()

    def get_pricing(self, **kwargs):
        # only useful to be able to launch ow without oe
        return {}
